unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  windows, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, ExtCtrls, syncobjs;

type
  tt1=class(TThread)
  public
    procedure Execute; override;
    procedure done;
  end;

  tt2=class(TThread)
  public
    procedure Execute; override;
  end;



  { TForm1 }

  TForm1 = class(TForm)
    btnNoYield: TButton;
    btnYield: TButton;
    lblResultCount: TLabel;
    lblCounter: TLabel;
    lblResultCountString: TLabel;
    lblCounterString: TLabel;
    ListView1: TListView;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure btnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1Data(Sender: TObject; Item: TListItem);
    procedure Timer1Timer(Sender: TObject);
  private

  public
    procedure done;
    procedure refreshList;
  end;

var
  Form1: TForm1;

  t1: tt1;
  t2: tt2;

  startevent: tevent;

  results: array of UInt64;
  resultcount: integer;
  counter: uint64;
  usesleep0: boolean;


implementation

{$R *.lfm}

{ TForm1 }

const
  MAX_COUNT = 20000;

procedure TForm1.refreshList;
begin
  listview1.Items.count:=resultcount;
  listview1.Refresh;
end;

procedure TForm1.done;
begin
  refreshList;
  btnNoYield.enabled:=true;
  btnYield.enabled:=true;

  freeandnil(t1);
  freeandnil(t2);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetProcessAffinityMask(GetCurrentProcess,1); //first cpu (yeah I know this is binary)
  SetThreadAffinityMask(GetCurrentThread,1);

  setlength(results, MAX_COUNT);

  startevent:=TEvent.Create(nil,true,false,'');

end;

procedure TForm1.ListView1Data(Sender: TObject; Item: TListItem);
begin
  item.caption:=inttostr(results[item.index]);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  lblResultCount.caption:=inttostr(resultcount);
  lblCounter.caption:=inttostr(counter);
end;

const
  YieldOn   = 'Yield is ON';
  YieldOff  = 'Yield is OFF';

  YieldText : pchar = nil;

procedure TForm1.btnClick(Sender: TObject);
begin
  //startevent.SetEvent;
  if t1<>nil then freeandnil(t1);
  if t2<>nil then freeandnil(t2);

  btnNoYield.enabled:=false;
  btnYield.enabled:=false;

  usesleep0:=tbutton(sender).tag=1;

  YieldText := YieldOff;
  if UseSleep0 then YieldText := YieldOn;

  //startevent.ResetEvent;

  t1:=tt1.Create(false);
  t2:=tt2.Create(false);

  //startevent.SetEvent;
end;


procedure tt1.done;
begin
  form1.done;
end;

procedure tt1.Execute;
begin
  //startevent.WaitFor(infinite);

  writeln;
  writeln('thread 1 started - ', YieldText);
  writeln;

  resultcount := 0;
  while (resultcount < MAX_COUNT) do
  begin
    results[resultcount]:=results[resultcount]+counter; //Just making sure there's no compiler optimization being done here
    inc(resultcount);
    if usesleep0 then sleep(0); //yield;
    writeln('from tt1 : ', resultcount);
  end;

  queue(@done);
end;

procedure tt2.Execute;
begin
  //startevent.WaitFor(infinite);

  writeln;
  writeln('thread 2 started - ', YieldText);
  writeln;

  counter := 0;
  while counter < MAX_COUNT do
  begin
    counter:=counter+1;
    if usesleep0 then
      sleep(0); //yield

    writeln('from tt2 : ', counter);
  end;
end;


end.

